\section{Developer Documentation}

In this section of the document we will outline some of the implementation details of the GUI. This document aims to give future developers a rough understanding of the systems that we put in place, but it will not go into much detail about every single line in every single function, because the code will certainly be subject to change in the future. We will only dive deeper into the code if we consider it necessary for understanding the implementation.

For further reference and additional details, the Doxygen documentation in the source code can be consulted.



\subsection{The Qt Framework}

For this document we will assume that the reader is familiar with all Qt concepts, as this should not turn out to be a Qt manual. At the time of completion of this project, Qt 5.13 was used, and its detailed documentation can be found on the official Qt website: \url{https://doc.qt.io/qt-5/index.html}. 

It is important to understand certain special aspects of Qt, e.g. the concept behind the "signals and slots" mechanism, which can connect function calls of different objects to each other by using a sort of "meta object system". In the code this is done with C++ macros, which appear in the header files, e.g. the keywords \lstinline{signals}, \lstinline{slots} or \lstinline{Q_OBJECT}.

For someone who is only familiar with C++ but not the Qt framework, certain aspects of Qt may not be intuitive at first, e.g. we want to draw attention to the fact that a function like \\
\lstinline{void on_tabWidget_currentChanged(int index)} \\
will automatically be called by the \lstinline{tabWidget} object once its \lstinline{currentChanged} signal was triggered/emitted, e.g. after the user selected a different tab. The connection between the \lstinline{tabWidget} object and this function (or "slot") is made \textit{based on the function name!} Therefore the functions with the "\lstinline{on_}" prefix should not be renamed by developers, unless they know what they are doing.

The repository also contains some {\tt .ui} files, which contain the layout of a certain widget or window, and can be opened and edited with drag-and-drop controls using the "Qt Creator" software. All the static UI elements and their properties are defined inside these files.

In our class diagrams we may also simplify some relations between a widget class and its UI elements. Technically, all static UI elements defined in a {\tt .ui} file are not members of the widget directly, but are always accessed through a pointer called \lstinline{ui} pointing to another class, which lives in the \lstinline{Ui} namespace and is automatically generated by the "Meta-Object Compiler" ("moc") when compiling the program with CMake.

To illustrate this, let's make an example: Take a look at the \lstinline{InputWidget} class. It has a pointer \\
\lstinline{Ui::InputWidget *ui} \\
which points to an object of its "cousin" class, containing all the UI elements which are specified in the {\tt inputwidget.ui} file. In some class diagrams we will just display the members of \lstinline{Ui::InputWidget} as members of \lstinline{InputWidget}, to avoid a lot of clutter in the diagrams.



\subsection{Main Window – {\tt MainWindow}}

The Main Window is responsible for high level operations such as saving and loading data from files, as well as all the menu actions and keyboard shortcuts.

It only contains very few UI elements in its {\tt mainwindow.ui} file, only a menu bar with all the different actions the user can take, as well as the main tab bar with the three tabs. The keyboard shortcuts for the actions (e.g. "Ctrl+S" for saving) are also defined in the {\tt mainwindow.ui} file and can be changed using Qt Creator. The behavior of the actions is very straightforward and defined in the private slots of the window, with very little code, since lengthier actions such as saving and loading of files is outsourced into a separate class (see \ref{sec:InputOutput}).

The main task of this class is to always adjust the GUI's behavior depending on which main tab is currently displayed. This is why many functions of the main window use \lstinline{switch} statements operating on the \lstinline{enum TabIndex} e.g. to open different save/load dialogs depending on whether the Input or Output Tab is currently displayed. 

The \lstinline{void updateUI()} routine mostly just updates the UI of the currently visible child tab, but also enables and disables menu options depending on which actions are valid in the active tab. 



\input{DevDoc/InputTab}

\input{DevDoc/RunTab}

\input{DevDoc/OutputTab}

\input{DevDoc/Misc}

\input{DevDoc/DyOSInterface}



\subsection{Testing}

As part of our assignment, we were required to test our GUI with two different example benchmark cases, which are a simple model of a car (also used in our tutorial, section \ref{sec:Tutorial}) and the well-known "Williams‐Otto" process. Both models use a different eso format, so we are also testing the JADE and FMI interfaces with these two cases.

Since we had to run these test cases many times during development, we also ended up implementing both of them into the GUI as a hard-coded example. This idea turned out to be great, and the AVT.SVT asked us to keep these convenient example cases in the GUI as another feature. They are accessible via the menu bar, or even via keyboard shortcut, e.g. {\tt Ctrl+1} for the car test case.

These test cases are pretty much guaranteed to run, since the GUI was designed keeping them in mind, and DyOS itself also has no problem with these fairly small models. However, we did not test models containing a lot more parameters and variables, which is something that would certainly highlight a few areas in our GUI that are not suitable for those kind of large models. Of course we always tried to also keep these larger models in mind when we designed the UI (see \ref{sec:KeyPrinciples}), but we can not guarantee that we didn't overlook something crucial, or that our GUI's performance doesn't drop significantly in those cases.

When it comes to things like unit testing or continuous integration, our group simply lacked the time to design these systems properly. We also believe that a fully fledged testing framework might be a little out of scope for a small program like this, but perhaps it would be worthwhile to at least include a few automatic test cases in the future. DyOS itself certainly already has a testing framework, and it also makes more sense to test the actual optimization rather than the GUI. A GUI in general is  hard to test automatically, since aspects like "how intuitive is it" or "does it look nice" can't be formalized well, and the very nature of GUIs is not linear, because the user has an almost infinite amount of possibilities to use them.

For testing the validity of the user's inputs, e.g. whether a number has the correct format, we tried to code these aspects of the GUI very defensively, and tried to think of ways the user could abuse the system. We don't claim that we successfully covered all ways the user could mess with the GUI, there certainly still are countless ways we overlooked, and perhaps a future version of the GUI should include a standardized way of checking these inputs, perhaps also using the \lstinline{QValidator} class.



\subsection{Challenges and Limitations}

Our group sometimes came across problems which we were not able to solve in an ideal way. All of these problems concern things which we are unable to change, for example parts of DyOS own code or of Qt, which lie outside of our control. We still always tried to work around these limitations, and found ways to weaken the impact these problems would have on our final product. Still, we would encourage the AVT.SVT to consider fixing these issues on a more fundamental level, and then remove our fixes for these issues, since they sometimes make the code more verbose than it needs to be and less elegant.


\subsubsection{Interrupting DyOS' Execution}\label{sec:ThreadInterruptProblems}

One big limitation of our current implementation is the fact that DyOS can not be stopped or interrupted by the user once it is running, without closing the GUI entirely. There are good reasons for this design decision.

Because we don't want the GUI to freeze completely once DyOS is running, we have to execute it in a separate thread or process. We have decided to use a thread, since it would be difficult to hand over the input \& output data to a separate process, and also to send messages back and forth, e.g. the command line output of DyOS and so on. It is certainly possible to use a process instead of a thread, but we believe that the implementation is a lot cleaner and straightforward to understand using a thread.

However, because DyOS is allocating dynamic memory, this memory would not be deallocated correctly if we interrupt the thread, which would result in large memory leaks. \lstinline{QThread} does posses a function \lstinline{QThread::terminate()}, but even the official Qt documentation advises developers to only use it if it is absolutely necessary (\url{https://doc.qt.io/qt-5/qthread.html#terminate}). The thread could be doing a system call or could be in the middle of updating a data structure when it is terminated, which could leave the program or even the OS in an unstable state.

Of course this was never an issue in the old version of DyOS, since it was a standalone process that could be interrupted using {\tt Ctrl+C} at any time. The operating system could then deallocate any remaining dynamic memory which was not deallocated by DyOS.

Our proposition to fix this issue would be to build something into DyOS that would allow the GUI to interrupt it, e.g. by setting a (yet to be implemented) flag \lstinline{bool shouldTerminate} or calling a function \lstinline{void requestInterruption()}. These methods could then be used by the GUI, and one could add a "Stop" button in the Run Tab.



\subsubsection{Assert Statements in DyOS}\label{sec:AssertProblems}

As described in the Concept section (\ref{sec:Concept}), the GUI implementation tries to reuse as many functions from the DyOS code as possible, to avoid duplicated structures which are hard to maintain. We always do so in \lstinline|try {...} catch {...}| statements, so that the GUI can continue to operate, even if an error occurs in a DyOS function. In most cases it also makes sense to display the content of the \lstinline{exception} in a small dialog window, which lets the user know what happened.

However, DyOS does not always use proper exceptions, but will sometimes use \lstinline{assert(...)} statements to check if certain conditions are met. Previously, when no GUI for DyOS existed, this used to be a good approach. The program most likely had no other choice but to terminate in these situations. But now, e.g. if we only want to use \lstinline{convertInput(...)} to check if an input object is valid, we \textit{do not} want the GUI to crash all of the sudden, without any chance to inform the user about what happened.

One good example of why this is a pain, is our choice to always have at least one stage in each input that is opened in the GUI. In theory, one could argue that a freshly created input should have zero stages at the start, and it would also be \textbf{much} more elegant in the code, since the constructor of the \lstinline{UserInput::Input} object would already produce a valid object. However, if an input with zero stages gets anywhere \textit{close} to a DyOS function, the current version of DyOS will completely bail. We have no choice but to always make sure that one stage remains in the input, which results in a little bit of extra code that should not be necessary.



\subsubsection{"Unsaved Changes" Dialog not reliable}\label{sec:UnsavedChangesProblems}

The "unsaved changes" dialog in the Input Tab relies on remembering a "last saved" version of the input object, and then comparing the current input to this last saved state. If both of them are identical, we know that the user has not made any unsaved changes, and e.g. we can safely delete the input object.

The implementation uses \lstinline{bool Input::operator==(...)} to compare the two input objects to each other, which can be found in \\{\tt UserInput.hpp}. This operator in turn also relies on all other \lstinline{operator==(...)} implementations in the smaller components of the input object, e.g. \\\lstinline{bool IntegratorInput::operator==(...)}. Unfortunately, at the time of writing this document, these operators are not implemented correctly for this purpose, and the GUI team is not allowed to change its implementation in the DyOS code.

To fix this issue we advise that all \lstinline{operator==(...)} implementations should be fixed, in such a way that they only return \lstinline{true} if two objects have identical values stored in all their member variables. Right now, e.g. the member \lstinline{integratorOptions} in \lstinline{struct IntegratorInput} is not compared, which means that changing any integrator options will not trigger the "unsaved changes" warning dialog.



\subsubsection{Command Line Output not working in all cases}\label{sec:CommandOutputProblems}

Unfortunately, the solution we developed to display the command line output in the GUI does not yet work with all different optimizers one can choose. We don't know the reason behind this, but we suspect that DyOS is essentially "stealing" the \lstinline{std::streambuf} position in \lstinline{std::cout} from us again, for its own custom logger system.

There is not much we can do to circumvent this. One idea would be to just use DyOS' official logger system for the output and debugging messages, however our team did not test this sufficiently, and we don't know whether the logger system is actually used consistently across DyOS' code. The other option would be to prevent DyOS from replacing the buffer of \lstinline{std::cout} again.



\subsubsection{Output Qt Problems}\label{sec:QTProblems}

The library for Qt Charts has a lot of functionality, but also has a few minor flaws. For example, the combination of different line and bar series into a chart is possible, but adding whiskers (\lstinline{QBoxSet} objects) from a "boxplot" is not. The different types of QCharts aren't fully compatible, so that we had to add our own markers in the \lstinline{Visualizer} class, see chapter \ref{sec:Visualizer}. Also, the ownership of objects is sometimes a bit unclear, and one sometimes doesn't know whether one has to manually deallocate the memory for some of them, and not for others. It is also not possible to easily manipulate the legend of a \lstinline{QChart}, even though a class \lstinline{QLegend} exists, because one can not just simply create or delete \lstinline{QLegend} objects. 



\subsection{Future Outlook}\label{sec:FutureOutlook}

A couple of things were not added to the GUI by our group, even though they might make sense to consider in the future. The time and scope of the project simply weren't large enough to implement them.

\begin{figure}[H]
    \centering
    \includegraphics[width=\textwidth]{Resources/futureOutlook}
    \caption{Future 
    Outlook}
    \label{fig:futureOutlook}
\end{figure}{}

\begin{itemize}
    \item \textbf{Complete input object parity:} A couple of components and sub components of the input object are currently not visible or editable in the Input Tab, but can only be seen in the input summary in the Run Tab. It should be a long term goal of this software to show the input object as a whole, since every option in the input object has a purpose and effect in DyOS.
    
    \item \textbf{JADE2:} We only considered the FMI and JADE model interfaces for this project, but the JADE2 interface, which is currently in development, should also be available in the future.

    \item \textbf{More plotting options:} Currently, the amount of options the user has to customize the plot in the Output Tab are very limited. This was mostly due to time constraints, but in principle functions like axis scaling, zoom, dragging or color/line options would be a nice addition.
    
    \item \textbf{Other export formats:} At the moment, the user can only save the output object as a JSON or XML text file, but this is not a very suitable format for opening the results in other programs. This format is only natively compatible with the GUI itself, and some smaller tool programs the AVT.SVT may have developed. In the future one should consider a dedicated format for just the plottable data points, and maybe look at more standardized file formats for this purpose.
    
    \item \textbf{Printing / Image export:} Once the GUI has been extended with more plotting options and a nicer looking chart, one may consider adding native printer support and PDF export, as well as image export.
    
    \item \textbf{More input examples and output examples:} Right now, the GUI has only three hard-coded input examples, which are accessible via keyboard shortcuts or the menu bar. In the future, one should reconsider whether these examples are well chosen in terms of their parameters, and maybe change them a little bit to highlight specific aspects of DyOS and the GUI. A few more examples should also be added, and perhaps also a few output examples, such that DyOS does not have to be run to test something in the Output Tab.

    \item \textbf{A proper tutorial:} The tutorial described in \ref{sec:Tutorial} could be implemented in the GUI as a guided step-by-step tour, with hovering explanations for the different options and so on. However, this would take quite some time to implement, and perhaps would not make sense to add in a non-commerical scientific piece of software, where one would assume that all users have at least a rough idea of what they're doing, and won't fail to use the software because they don't know how a GUI works. Having the tutorial in the code would also make the software harder to maintain.
\end{itemize}